/**
 * 
 * $Id: NumberUtil.java,v 1.3 2008/12/09 02:13:15 aoki Exp $
 */
package util;

/**
 * lׂ̃[eBeBNXłB
 * 
 * @author aoki
 */
public class NumberUtil {

    private NumberUtil() {
        // CX^X𐶐Ȃ
    }

    /**
     * ̕AO𔭐Longɕϊ܂B<br/>
     * ϊoȂꍇnullԂ܂B
     * 
     * @param target ϊΏۂ̕
     * @return ϊLong or null
     */
    public static Long parseLongObj(String target) {
        return parseLongObj(target, null);
    }
    
    /**
     * ̕AO𔭐Longɕϊ܂B<br/>
     * ϊoȂꍇdefValueԂ܂B
     * 
     * @param target ϊΏۂ̕
     * @param defValue ϊoȂꍇɕԂl
     * @return ϊLong or defValue
     */
    public static Long parseLongObj(String target, Long defValue) {
        if (isInteger(target)) {
            return Long.valueOf(target);
        }
        return defValue;
    }
    
    /**
     * ̕AO𔭐longɕϊ܂B<br/>
     * ϊoȂꍇ0Ԃ܂B
     * 
     * @param target ϊΏۂ̕
     * @return ϊlongl
     */
    public static long parseLong(String target) {
        return parseLong(target, 0);
    }
    
    /**
     * ̕AO𔭐longɕϊ܂B<br/>
     * ϊoȂꍇdefValueԂ܂B
     * 
     * @param target ϊΏۂ̕
     * @param defValue ϊoȂꍇɕԂl
     * @return ϊlongl or defValue
     */
    public static long parseLong(String target, long defValue) {
        if (isInteger(target)) {
            return Long.parseLong(target);
        }
        return defValue;
    }
    
    /**
     * ̕AO𔭐Integerɕϊ܂B<br/>
     * ϊoȂꍇnullԂ܂B
     * 
     * @param target ϊΏۂ̕
     * @return ϊInteger or null
     */
    public static Integer parseInteger(String target) {
        return parseInteger(target, null);
    }
    
    /**
     * ̕AO𔭐Integerɕϊ܂B<br/>
     * ϊoȂꍇdefValueԂ܂B
     * 
     * @param target ϊΏۂ̕
     * @param defValue ϊoȂꍇɕԂl
     * @return ϊInteger or defValue
     */
    public static Integer parseInteger(String target, Integer defValue) {
        if (isInteger(target)) {
            return Integer.valueOf(target);
        }
        return defValue;
    }
    
    /**
     * ̕AOintɕϊ܂B<br/>
     * ϊłȂꍇ0Ԃ܂B
     * 
     * @param target ϊΏە
     * @return intɕϊ
     */
    public static int parseInt(String target) {
        return parseInt(target, 0);
    }
    
    /**
     * ̕AO𔭐intɕϊ܂B<br/>
     * ϊłȂꍇdefValueԂ܂B
     * 
     * @param target ϊΏە
     * @param defValue ϊoȂꍇ̃ftHgl
     * @return ϊ㐔ldefValue
     */
    public static int parseInt(String target, int defValue) {
        if (isInteger(target)) {
            return Integer.parseInt(target);
        }
        return defValue;
    }
    
    /**
     * ̕AO𔭐鎖Ȃdoubleɕϊ܂B<br />
     * ϊoȂꍇ0.0Ԃ܂B
     * 
     * @param target ϊΏۂ̕
     * @return doubleɕϊ
     */
    public static double parseDouble(String target) {
        return parseDouble(target, 0.0);
    }
    
    /**
     * ̕AO𔭐鎖Ȃdoubleɕϊ܂B<br />
     * ϊoȂꍇdefValueԂ܂B
     * 
     * @param target ϊΏۂ̕
     * @param defValue ϊoȂꍇ̃ftHgl
     * @return doubleɕϊʁBdefValueB
     */
    public static double parseDouble(String target, double defValue) {
        try {
            return Double.parseDouble(target);
        } catch (NumberFormatException e) {
            return defValue;
        }
    }
    
    /**
     * ̕AO𔭐鎖Ȃfloatɕϊ܂B<br />
     * ϊoȂꍇ0.0Ԃ܂B
     * 
     * @param target ϊΏۂ̕
     * @return floatɕϊ
     */
    public static float parseFloat(String target) {
        return parseFloat(target, 0.0f);
    }
    
    /**
     * ̕AO𔭐鎖Ȃfloatɕϊ܂B<br />
     * ϊoȂꍇdefValueԂ܂B
     * 
     * @param target ϊΏۂ̕
     * @param defValue ϊoȂꍇ̃ftHgl
     * @return floatɕϊʁBdefValueB
     */
    public static float parseFloat(String target, float defValue) {
        try {
            return Float.parseFloat(target);
        } catch (NumberFormatException e) {
            return defValue;
        }
    }
    
    /**
     * ̕AO𔭐鎖ȂDoubleɕϊ܂B<br />
     * ϊoȂꍇDouble.valueOf(0.0)Ԃ܂B
     * 
     * @param target ϊΏۂ̕
     * @return Doubleɕϊ
     */
    public static Double parseDoubleObj(String target) {
        return parseDoubleObj(target, Double.valueOf(0.0));
    }
    
    /**
     * ̕AO𔭐鎖ȂDoubleɕϊ܂B<br />
     * ϊoȂꍇdefValueԂ܂B
     * 
     * @param target ϊΏۂ̕
     * @param defValue ϊoȂꍇ̃ftHgl
     * @return DoubleɕϊʁBdefValueB
     */
    public static Double parseDoubleObj(String target, Double defValue) {
        try {
            return Double.valueOf(target);
        } catch (NumberFormatException e) {
            return defValue;
        }
    }
    
    /**
     * target10i̐ɕϊ\łꍇtrueԂ܂B<br/>
     * intɃI[o[t[ɕϊ\ǂ͌؂܂B
     * 
     * @param target ؂镶
     * @return targetɕϊ\łꍇtrue
     */
    public static boolean isInteger(String target) {
        if (target == null) {
            return false;
        }
        target = target.trim();
        if (target.length() < 1) {
            return false;
        }
        int start = 0;
        char c = target.charAt(start++);
        int len = target.length();
        if (c == '0' && len == 1) {
            return true;
        }
        if (c == '-') {
            if (len == 1) {
                return false;
            }
            c = target.charAt(start++);
        }
        if (c > '9' || c < '1') {
            return false;
        }
        for (int i = start; i < len; i++) {
            c = target.charAt(i);
            if (c > '9' || c < '0') {
                return false;
            }
        }
        return true;
    }
    
}
