/**
 * 
 * $Id: PropUtil.java,v 1.5 2009/08/22 14:59:46 aoki Exp $
 */
package util;

import java.text.MessageFormat;
import java.util.Properties;

/**
 * java.util.Propertiesɑ΂鑀sUtilityNXłB<br />
 * PropertiesƂ͈قȂASĂ̑{@link String#trim()}s܂B
 * 
 * @author aoki
 */
public class PropUtil {

    private PropUtil() {
        // CX^X𐶐Ȃ
    }
    
    /**
     * propskeyŕ擾AIntegerɕϊĕԂ܂B<br/>
     * keyɑΉvpeB݂ȂꍇA܂́AInteger
     * ϊoȂꍇdefValueԂ܂B
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @param defValue vpeB݂ȂA
     *         ܂͕ϊoȂꍇ̃ftHgl
     * @return ϊInteger or defValue
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static Integer getInteger(
            Properties props, String key, Integer defValue) {
        String value = props.getProperty(key);
        if (value != null) {
            value = value.trim();
        }
        return NumberUtil.parseInteger(value, defValue);
    }
    
    /**
     * propskeyŕ擾AIntegerɕϊĕԂ܂B<br/>
     * keyɑΉvpeB݂ȂꍇA܂́AInteger
     * ϊłȂꍇnullԂ܂B
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @return ϊInteger or null
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static Integer getInteger(Properties props, String key) {
        return getInteger(props, key, null);
    }
    
    /**
     * propskeyŕ擾AintɕϊĕԂ܂B<br/>
     * keyɑΉvpeB݂ȂꍇA܂́Aint
     * ϊłȂꍇdefValueԂ܂B
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @param defValue vpeB݂ȂA
     *         ܂͕ϊłȂꍇ̃ftHgl
     * @return ϊintl or defValue
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static int getInt(Properties props, String key, int defValue) {
        String value = props.getProperty(key);
        if (value != null) {
            value = value.trim();
        }
        return NumberUtil.parseInt(value, defValue);
    }
    
    /**
     * propskeyŕ擾AintɕϊĕԂ܂B<br/>
     * keyɑΉvpeB݂ȂꍇA܂́Aint
     * ϊłȂꍇ0Ԃ܂B
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @return ϊintl or 0
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static int getInt(Properties props, String key) {
        return getInt(props, key, 0);
    }
    
    /**
     * propskeyŕ擾AdoubleɕϊĕԂ܂B<br/>
     * keyɑΉvpeB݂ȂꍇA܂́Adouble
     * ϊłȂꍇdefValueԂ܂B
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @param defValue vpeB݂ȂA
     *         ܂͕ϊłȂꍇ̃ftHgl
     * @return ϊdoublel or defValue
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static double getDouble(Properties props, String key, double defValue) {
        String value = props.getProperty(key);
        if (value != null) {
            value = value.trim();
        }
        return NumberUtil.parseDouble(value, defValue);
    }
    
    /**
     * propskeyŕ擾AdoubleɕϊĕԂ܂B<br/>
     * keyɑΉvpeB݂ȂꍇA܂́Adouble
     * ϊłȂꍇ0.0Ԃ܂B
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @return ϊdoublel or 0.0
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static double getDouble(Properties props, String key) {
        return getDouble(props, key, 0.0);
    }
    
    /**
     * propskeyŕ擾AfloatɕϊĕԂ܂B<br/>
     * keyɑΉvpeB݂ȂꍇA܂́Afloat
     * ϊłȂꍇdefValueԂ܂B
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @param defValue vpeB݂ȂA
     *         ܂͕ϊłȂꍇ̃ftHgl
     * @return ϊfloatl or defValue
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static float getFloat(Properties props, String key, float defValue) {
        String value = props.getProperty(key);
        if (value != null) {
            value = value.trim();
        }
        return NumberUtil.parseFloat(value, defValue);
    }
    
    /**
     * propskeyŕ擾AfloatɕϊĕԂ܂B<br/>
     * keyɑΉvpeB݂ȂꍇA܂́Afloat
     * ϊłȂꍇ0.0Ԃ܂B
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @return ϊfloatl or 0.0
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static float getFloat(Properties props, String key) {
        return getFloat(props, key, 0.0f);
    }
    
    /**
     * propskeyŕ擾AlongɕϊĕԂ܂B<br/>
     * keyɑΉvpeB݂ȂꍇA܂́Along
     * ϊłȂꍇdefValueԂ܂B
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @param defValue vpeB݂ȂA
     *         ܂͕ϊłȂꍇ̃ftHgl
     * @return ϊlongl or defValue
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static long getLong(Properties props, String key, long defValue) {
        String value = props.getProperty(key);
        if (value != null) {
            value = value.trim();
        }
        return NumberUtil.parseLong(value, defValue);
    }
    
    /**
     * propskeyŕ擾AlongɕϊĕԂ܂B<br/>
     * keyɑΉvpeB݂ȂꍇA܂́Along
     * ϊłȂꍇ0Ԃ܂B
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @return ϊlongl or 0
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static long getLong(Properties props, String key) {
        return getLong(props, key, 0);
    }
    
    /**
     * propskeyŕ擾ALongɕϊĕԂ܂B<br/>
     * keyɑΉvpeB݂ȂꍇA܂́ALong
     * ϊłȂꍇdefValueԂ܂B
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @param defValue vpeB݂ȂA
     *         ܂͕ϊłȂꍇ̃ftHgl
     * @return ϊLong or defValue
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static Long getLongObj(Properties props, String key, Long defValue) {
        String value = props.getProperty(key);
        if (value != null) {
            value = value.trim();
        }
        return NumberUtil.parseLongObj(value, defValue);
    }
    
    /**
     * propskeyŕ擾ALongɕϊĕԂ܂B<br/>
     * keyɑΉvpeB݂ȂꍇA܂́ALong
     * ϊłȂꍇnullԂ܂B
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @return ϊLong or null
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static Long getLongObj(Properties props, String key) {
        return getLongObj(props, key, null);
    }
    
    /**
     * propskeyŕ擾܂B<br/>
     * keyɑΉvpeB݂ȂꍇAnullԂ܂B
     * {@link Properties#getProperty(String)}{@link String#trim()}
     * p̂ƓłBiʂnull̏ꍇtrims܂Bj
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @return keyɑΉl or null
     */
    public static String getString(Properties props, String key) {
        return getString(props, key, null);
    }
    
    /**
     * propskeyŕ擾܂B<br/>
     * keyɑΉvpeB݂ȂꍇAdefValueԂ܂B
     * {@link Properties#getProperty(String,String)}{@link String#trim()}
     * p̂ƓłBiʂnull̏ꍇtrims܂Bj
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @param defValue vpeB݂Ȃꍇ̃ftHgl
     * @return keyɑΉl or defValue
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static String getString(Properties props, String key, String defValue) {
        String value = props.getProperty(key);
        if (value != null) {
            return value.trim();
        }
        return defValue;
    }
    
    /**
     * propskeyŎ擾tH[}bg
     * arguments𖄂ߍŕԂ܂B<br/>
     * keyɑΉvpeB݂ȂꍇAdefValue
     * pătH[}bg܂B
     * 
     * @param props ΏۂProperties
     * @param key vpeB̃L[
     * @param defValue vpeB݂Ȃꍇ̃ftHgl
     * @param arguments tH[}bgւ̈
     * @return keyɑΉldefValuetH[}bg
     * @see java.text.MessageFormat#format(String, Object[])
     * @see java.util.Properties#getProperty(String, String)
     * @throws NullPointerException propsnull̏ꍇ
     */
    public static String getString(
            Properties props, String key, String defValue, Object ... arguments) {
        String value = props.getProperty(key, defValue);
        if (value != null) {
            value = value.trim();
        }
        return MessageFormat.format(value, arguments);
    }
}
