/**
 * 
 * $Id: StringUtil.java,v 1.10 2009/07/23 10:46:54 todoroki Exp $
 */
package util;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.Random;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 񑀍s[eBeBNXłB
 * 
 * @author s.aoki
 */
public final class StringUtil {
    private static final String ASCII_CHARSET = "ISO-8859-1";
    private final static Pattern BR_TAG_PATTERN =
        Pattern.compile("<\\s*br\\s*/?\\s*>", Pattern.CASE_INSENSITIVE);
    /**
     * URL̐K\łB
     */
    public static final String URL_PATTERN_STRING =
    	// XL[}
	    "(?i:https?)://" +
	    // IP v4 or domain start
	    "(?:" +
	    // ip address
	    "(?:[0-9]{1,3}(?:\\.[0-9]{1,3}){3})" +
	    // or
	    "|" +
	    // hostname
	    "(?:[\\-\\w]+(?:\\.[\\-\\w]+)*(?:\\.[\\-\\w]{2,6}))" +
	    // IP v4 or domain end
	    ")" +
	    // port number
	    "(?::[0-9]+)?" +
	    // I͌p̍mǂ
	    "(?=/|\\?|\\s|\n|\\W|$)" +
	    // ̑
	    "(?:[/?](?=\\S*)[\\-_.!~*'()\\w;/?:@&=+$,%#]*)?" +
	    // ےǂ݂pďIp^[`
	    "(?!\\W)?";

    private static final Pattern URL_PATTERN =
        Pattern.compile(URL_PATTERN_STRING);

    // CX^X𐶐ȂB
    private StringUtil() {
        // do nothing.
    }

    /**
     * ̐擪Ɩɋ󔒕iSp܂ށjΏĕԂ܂B
     * 
     * @param str ϊΏۂ̕
     * @return ϊ̕
     */
    public static String trimIncludingFullSize(String str) {
        int len = str.length();
        int st = 0;
        char[] val = str.toCharArray();
        while ((st < len) && (val[st] <= ' ' || val[st] == '@')) {
            st++;
        }
        while ((st < len) && (val[len - 1] <= ' ' || val[len - 1] == '@')) {
            len--;
        }
        return ((st > 0) || (len < str.length())) ? str.substring(st, len)
                : str;
    }

    /**
     * s'&lt;br /&gt;'ɕϊĕԂ܂B
     * 
     * @param str ϊΏۂ̕
     * @return ϊ̕
     */
    public static String newlineToBR(String str) {
        if (str == null || str.length() < 1) {
            return str;
        }
        str = unifyNewline(str);
        if (str.indexOf('\n') != -1) {
            str = str.replace("\n", "<br />");
        }
        return str;
    }

    /**
     * &lt;br&gt;^O\nɕϊĕԂ܂B
     * 
     * @param str ϊΏۂ̕
     * @return ϊ̕
     */
    public static String brToNewline(String str) {
        if (str == null || str.length() < 1) {
            return str;
        }
        str = BR_TAG_PATTERN.matcher(str).replaceAll("\n");
        return str;
    }
    
    /**
     * targetɉs܂܂ĂꍇɁALFɓꂵ
     * Ԃ܂B
     * 
     * @param target ϊΏۂ̕
     * @return ꏈ̕BtargetnullꍇnullB
     */
    public static String unifyNewline(String target) {
        if (target == null || target.length() < 1) {
            return target;
        }
        if (target.indexOf("\r\n") > -1) {
            target = target.replace("\r\n", "\n");
        }
        if (target.indexOf('\r') > -1) {
            target = target.replace('\r', '\n');
        }
        return target;
    }

    /**
     * 32bytei[0-9A-F]{64}j̃_16iԂ܂B
     * 
     * @return 32bytẽ_16i
     */
    public static String genRandomHexStr32() {
        return genRandomHexStr(32);
    }

    /**
     * byteNum bytẽ_16iԂ܂B
     * 
     * @param byteNum byte
     * @return byteNumoCg̃_16i
     * @throws IllegalArgumentException
     *             byteNum1̏ꍇ
     */
    public static String genRandomHexStr(int byteNum) {
        if (byteNum < 1) {
            throw new IllegalArgumentException(
                    "byteNum must be greater equal than \"1\".");
        }
        Random random = new Random(System.nanoTime());
        byte[] randomBytes = new byte[byteNum];
        random.nextBytes(randomBytes);
        StringBuilder sb = new StringBuilder(byteNum * 2);
        for (int i = 0; i < byteNum; i++) {
            sb.append(byteToHexString(randomBytes[i]));
        }
        return sb.toString().toUpperCase(Locale.US);
    }

    // convert byte to hex string
    private static String byteToHexString(byte b) {
        int i = (b < 0) ? b + 256 : b;
        String byteStr = Integer.toHexString(i);
        return byteStr.length() == 1 ? '0' + byteStr : byteStr;
    }

    /**
     * ASCII8ioCgɕϊ܂B<br/>
     * targetnull̏ꍇAnullԂ܂B<br/>
     * Ⴆ"1AaBbCc""061101141102142103143"ɕϊ܂B
     * 
     * @param target ϊΏۂƂȂ镶
     * @return 8ĩoCg
     */
    public static String convertASCIIToOctalString(String target) {
        if (target == null) {
            return null;
        }
        byte[] targetBytes;
        try {
            targetBytes = target.getBytes(ASCII_CHARSET);
        } catch (UnsupportedEncodingException e) {
            // Ȃ͂Ȃ̂ŁARuntimeExceptionɕϊ
            throw new RuntimeException(e);
        }
        StringBuilder sb = new StringBuilder(targetBytes.length * 3);
        for (int i = 0; i < targetBytes.length; i++) {
            String byteStr = Integer.toOctalString(targetBytes[i]);
            int len = byteStr.length();
            if (len < 3) {
                byteStr = len == 1 ? "00" + byteStr : '0' + byteStr;
            }
            sb.append(byteStr);
        }
        return sb.toString();
    }

    /**
     * ASCIIϊ8iA ASCIIɕϊ܂B<br/>
     * octalStringnull̏ꍇnullԂ܂B<br/>
     * Ⴆ"061101141102142103143""1AaBbCc"ɕϊ܂B<br/>
     * octalString̕3̔{ŖꍇA]̕𖳎A
     * ʂɂ͊܂߂܂B܂A[^0-7]̕ꍇA '0'Ƃĕ]܂B
     * 
     * @param octalString ϊΏۂƂȂ8i
     * @return XASCIIB
     */
    public static String convertOctalStringToASCII(String octalString) {
        if (octalString == null) {
            return null;
        }
        int len = octalString.length();
        int surplus = len % 3;
        if (surplus > 0) {
            // ]蕶𖳎
            len = len - surplus;
        }
        StringBuilder sb = new StringBuilder(len / 3);
        for (int i = 0, c = 0; i < len; i += 3, c++) {
            StringBuilder innerSb = new StringBuilder(3);
            for (int k = i; k < i + 3; k++) {
                char chr = octalString.charAt(k);
                if (chr > '7' || chr < '0') {
                    // [^0-7]̏ꍇA'0'ɕϊ
                    chr = '0';
                }
                innerSb.append(chr);
            }
            sb.append((char) Integer.parseInt(innerSb.toString(), 8));
        }
        return sb.toString();
    }

    /**
     * ASCIIMD5ňÍԂ܂B<br/>
     * Ⴆ΁Au123abcABCvƂ
     * u7A20603B2321E5AD941810026E02D280vƂɕϊ܂B
     * 
     * @param asciiString ϊΏۂ̕
     * @return ϊ̕
     */
    public static String convertASCIIToMessageDigest(String asciiString) {
        if (asciiString == null) {
            return null;
        }
        try {
            return convertBytesToMessageDigest(asciiString.getBytes(ASCII_CHARSET));
        } catch (UnsupportedEncodingException e) {
            // ASCIIT|[gĂȂ͂Ȃ͂Ȃ̂ŁAsOƂB
            throw new RuntimeException(e);
        }
    }
    
    /**
     * CӂbytezMD5ňÍԂ܂B<br />
     * {@link #convertASCIIToMessageDigest(String)}Ƃ͈قȂA
     * Ăяobytez𐶐ׁA̕ASCIIł
     * Kv͂܂B
     * 
     * @param bytes ϊΏۂbytez
     * @return ϊ̕
     */
    public static String convertBytesToMessageDigest(byte[] bytes) {
        if (bytes == null) {
            return null;
        }
        try {
            MessageDigest md = MessageDigest.getInstance("MD5");
            md.update(bytes);
            bytes = md.digest();
            StringBuilder sb = new StringBuilder(bytes.length * 2);
            for (int i = 0; i < bytes.length; i++) {
                sb.append(byteToHexString(bytes[i]));
            }
            return sb.toString().toUpperCase(Locale.US);
        } catch (NoSuchAlgorithmException e) {
            // JVMΉĂȂN肦Ȃ̂ŁAsOƂB
            throw new RuntimeException(e);
        }
    }

    /**
     * datefmtiFyyyyMMddjStringɕϊ܂B<br/>
     * SimpleDateFormatpĕϊ郆[eBeB\bhłB<br/>
     * <b>tH[}bgŌJԂϊꍇADateFormatCX^X
     * ėpIłB̂悤ȏꍇA
     * ̃\bhJԂĂяoׂł͂܂B</b>
     * 
     * @param date Ώۂ̓tIuWFNg
     * @param fmt tH[}bg
     * @return w̃tH[}bg̓t
     * @throws IllegalArgumentException
     *             tH[}bg̃p^[słꍇ
     */
    public static String dateToStr(Date date, String fmt) {
        try {
            return new SimpleDateFormat(fmt).format(date);
        } catch (Exception e) {
            throw new IllegalArgumentException(e);
        }
    }

    /**
     * targetconvert̕Ń}XN܂B
     * 
     * @param target ϊΏۂ̕
     * @param convert }XN
     * @return }XLO
     */
    public static String maskString(String target, char convert) {
        int len = 0;
        if (target == null || (len = target.length()) == 0) {
            return target;
        }
        StringBuilder sb = new StringBuilder(len);
        for (int i = 0; i < len; i++) {
            sb.append(convert);
        }
        return sb.toString();
    }

    /**
     * targetURL\L܂܂ĂꍇɁA
     * URLA^Oň͂񂾕\LɂĕԂ܂B
     * {@link #decorateAnchor(String, com.joysound.util.StringUtil.HTMLAnchorCreator)}
     * HTMLAnchorCreatorp[^ɂ{@link BlankAnchorCreator}ݒ肵܂B
     * 
     * @param target ϊΏۂ̕
     * @return ϊ㕶
     * @see #decorateAnchor(String,
     *      com.joysound.util.StringUtil.HTMLAnchorCreator)
     */
    public static String decorateAnchor(String target) {
        return decorateAnchor(target, new BlankAnchorCreator());
    }

    /**
     * targetURL\L܂܂ĂꍇɁA
     * URLA^Oň͂񂾕\LɂĕԂ܂B<br/>
     * A^ȎHTMLAnchorCreator̎Ɉˑ܂B<br/>
     * URL̃p^[ɂ{@link #URL_PATTERN_STRING}p܂B
     * 
     * @param target ϊΏۂ̕
     * @param creator URLanchor^O̕\ɕϊIuWFNg
     * @return ϊ㕶
     * @throws NullPointerException
     *             creatornull̏ꍇ
     */
    public static String decorateAnchor(String target, HTMLAnchorCreator creator) {
        if (target == null) {
            return target;
        }
        Matcher m = URL_PATTERN.matcher(target);
        if (m.find()) {
            // A^O镪zđ₵Ă
            StringBuilder sb = new StringBuilder((int) (target.length() * 1.1));
            int prevEnd = 0;
            do {
                String url = m.group();
                int start = m.start();
                int end = m.end();
                if (prevEnd < start) {
                    sb.append(target.substring(prevEnd, start));
                }
                sb.append(creator.createAnchor(url));
                prevEnd = end;
            } while (m.find());
            if (target.length() > prevEnd) {
                sb.append(target.substring(prevEnd));
            }
            target = sb.toString();
        }
        return target;
    }

    /**
     * URLHTMLAnchor^OǉC^[tF[XłB<br/>
     * ɂĂURL̓eyђ[̎ʂɂSessionID
     * Iɕt܂B
     * 
     * @author Shinobu Aoki
     */
    public static interface HTMLAnchorCreator {
        /**
         * urlɑΉAnchor^Ot̕쐬ĕԂ܂B
         * 
         * @param url ΏۂURL
         * @return Anchor^OǉURL
         */
        String createAnchor(String url);
    }

    /**
     * HTMLAnchorCreator̎NXŁAtargetɂ"_blank"
     * Kw肵Anchor^O쐬܂B<br/> nꂽURL{@link StringUtil#convertHtmlEntityReferences(String)}
     * ϊKp܂B
     * 
     * @author Shinobu Aoki
     */
    public static class BlankAnchorCreator implements HTMLAnchorCreator {
        // javadocɍڂׂɃANZXCqpublicɂĂ܂
        /*
         * ( Javadoc)
         * 
         * @see com.joysound.util.StringUtil.HTMLAnchorCreator#createAnchor(java.lang.String)
         */
        public String createAnchor(String url) {
            url = convertHtmlEntityReferences(url);
            return "<a href=\"" + url + "\" target=\"_blank\">" + url + "</a>";
        }
    }

    /**
     * target̕Ɋ܂܂SpJ^Ji𔼊pJ^JiɕϊĕԂ܂B
     * 
     * @param target ϊΏۂ̕
     * @return ϊ̕
     */
    public static String convertZenToHanKana(String target) {
        return ZenHanKatakanaConverter.convert(target);
    }

    /**
     * target̕Ɋ܂܂锼pJ^JiSpJ^JiɕϊĕԂ܂B
     * 
     * @param target ϊΏۂ̕
     * @return ϊ̕
     */
    public static String convertHanToZenKana(String target) {
        return HanZenKatakanaConverter.convert(target);
    }

    // SpJipJiϊNX
    private static class ZenHanKatakanaConverter {
        private static final char[] ZEN =
            { 'J', 'K', 'T', 'U', '\u309F', '\u30A0', '@', 'A', 'B', 'C', 'D',
                    'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
                    'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\',
                    ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h',
                    'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't',
                    'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '', '',
                    '', '', '', '', '', '', '', '', '', '', '', '',
                    '', '', '', '', '', '', '', '', '', '\u30F7',
                    '\u30F8', '\u30F9', '\u30FA', 'E', '[', 'R', 'S' };
        private static final String[] HAN =
            { "", "", "T", "U", "\u309F", "\u30A0", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "\u30F7", "\u30F8", "\u30F9",
                    "\u30FA", "", "", "R", "S" };

        static String convert(String target) {
            if (target == null || target.length() < 1) {
                return target;
            }
            int len = target.length();
            StringBuilder sb = new StringBuilder(len);
            for (int i = 0; i < len; i++) {
                char c = target.charAt(i);
                if (c >= ZEN[0] && c <= ZEN[ZEN.length - 1]) {
                    sb.append(HAN[c - ZEN[0]]);
                } else {
                    sb.append(c);
                }
            }
            return sb.toString();
        }
    }

    // pJiSpJiϊNX
    private static class HanZenKatakanaConverter {
        private static final char[] ZEN =
            { 'J', 'K', 'T', 'U', '\u309F', '\u30A0', '@', 'A', 'B', 'C', 'D',
                    'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
                    'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\',
                    ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h',
                    'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't',
                    'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '', '',
                    '', '', '', '', '', '', '', '', '', '', '', '',
                    '', '', '', '', '\u30F7', '\u30F8', '\u30F9', '\u30FA',
                    'E', '[', 'R', 'S' };
        private static final String[] HAN =
            { "", "", "T", "U", "\u309F", "\u30A0", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "", "",
                    "\u30F7", "\u30F8", "\u30F9", "\u30FA", "", "", "R", "S" };

        static String convert(String target) {
            if (target == null || target.length() < 1) {
                return target;
            }
            // p̑_A_͌
            for (int i = HAN.length - 1; i >= 0; i--) {
                if (target.indexOf(HAN[i]) >= 0) {
                    target = target.replace(HAN[i], String.valueOf(ZEN[i]));
                }
            }
            return target;
        }
    }

    /**
     * target̕Ɋ܂܂J^JiЂ炪ȂɕϊĕԂ܂B
     * 
     * @param target ϊΏۂ̕
     * @return ϊ̕
     */
    public static String convertKatakanaToHiragana(String target) {
        return KatakanaToHiraganaConverter.convert(target);
    }

    /**
     * target̕Ɋ܂܂Ђ炪Ȃ𐴉ɕϊĕԂ܂B
     * 
     * @param target ϊΏۂ̕
     * @return ϊ̕()
     */
    public static String convertHiraganaToSeionHiragana(String target) {
        return HiraganaToSeionHiraganaConverter.convert(target);
    }

    /**
     * target̕Ɋ܂܂J^JiƂЂ炪Ȃ<br/>
     * Ђ炪()ɕϊԂ܂B
     * 
     * @param target ϊΏۂ̕
     * @return ϊ̕()
     */
    public static String convertKatakanaToSeionHiragana(String target) {
        String hiragana = KatakanaToHiraganaConverter.convert(target);
        return HiraganaToSeionHiraganaConverter.convert(hiragana);
    }

    // J^JiЂ炪ȕϊNX
	private static class KatakanaToHiraganaConverter {
		private static final char[] KATA = { 'J', 'K', 'T', 'U', '\u309F',
				'\u30A0', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
				'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U',
				'V', 'W', 'X', 'Y', 'Z', '[', '\', ']', '^', '_', '`', 'a',
				'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
				'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y',
				'z', '{', '|', '}', '~', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '',
				'\u30F7', '\u30F8', '\u30F9', '\u30FA', 'E', '[', 'R', 'S' };
		private static final char[] HIRA = { 'J', 'K', 'T', 'U', '\u309F',
				'\u30A0', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '',
				'\u30F7', '\u30F8', '\u30F9', '\u30FA', 'E', '[', 'R', 'S' };

		static String convert(String target) {
			if (target == null || target.length() < 1) {
				return target;
			}
			for (int i = KATA.length - 1; i >= 0; i--) {
				if (target.indexOf(KATA[i]) >= 0) {
					target = target.replace(KATA[i], HIRA[i]);
				}
			}
			return target;
		}
	}

	// Ђ炪ȁЂ炪()ϊNX
	private static class HiraganaToSeionHiraganaConverter {
		private static final char[] HIRA = { 'J', 'K', 'T', 'U', '\u309F',
				'\u30A0', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '',
				'\u30F7', '\u30F8', '\u30F9', '\u30FA', 'E', '[', 'R', 'S' };
		private static final char[] SEIHIRA = { 'J', 'K', 'T', 'U', '\u309F',
				'\u30A0', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '', '',
				'', '', '', '', '', '', '', '', '', '', '',
				'\u30F7', '\u30F8', '\u30F9', '\u30FA', 'E', '[', 'R', 'S' };

		/**
		 * @param target
		 *            Ђ炪
		 * @return target Ђ炪()
		 */
		static String convert(String target) {
			if (target == null || target.length() < 1) {
				return target;
			}
			for (int i = HIRA.length - 1; i >= 0; i--) {
				if (target.indexOf(HIRA[i]) >= 0) {
					target = target
							.replace(HIRA[i], SEIHIRA[i]);
				}
			}
			return target;
		}
	}

    /**
	 * targetHTML̓ꕶu&amp;, &#39;, &quot;, &gt; &lt;v
	 * ܂܂ĂꍇɁAQƕɒuĕԂ܂B
	 * 
	 * @param target
	 *            Ώۂ̕
	 * @return ϊ̕
	 */
    public static String convertHtmlEntityReferences(String target) {
        int len;
        if (target == null || (len = target.length()) == 0) {
            return target;
        }
        if (target.indexOf('"') == -1 && target.indexOf('\'') == -1
                && target.indexOf('&') == -1 && target.indexOf('<') == -1
                && target.indexOf('>') == -1) {
            return target;
        }
        StringBuilder sb = new StringBuilder(len);
        int lastIndex = 0;
        for (int i = 0; i < len; i++) {
            char c = target.charAt(i);
            String converted = null;
            switch (c) {
            case '"':
                converted = "&quot;";
                break;
            case '\'':
                converted = "&#39;";
                break;
            case '&':
                converted = "&amp;";
                break;
            case '<':
                converted = "&lt;";
                break;
            case '>':
                converted = "&gt;";
                break;
            }
            if (converted != null) {
                if (lastIndex < i) {
                    sb.append(target.substring(lastIndex, i));
                }
                sb.append(converted);
                lastIndex = i + 1;
            }
        }
        sb.append(target.substring(lastIndex));
        return sb.toString();
    }

    /**
     * ̎̕QƂɒuĕԂ܂B<br/> ϊȉɋL܂B<br/>
     * <ul>
     * <li>ϊOFABCDEabcde12345</li>
     * <li>ϊF&amp;#12354;&amp;#12356;&amp;#12358;&amp;#12360;&amp;#12362;
     * ABCDEabcde12345
     * &amp;#12363;&amp;#12365;&amp;#12367;&amp;#12369;&amp;#12371;</li>
     * </ul>
     * 
     * @param target ϊΏۂ̕
     * @return ϊʂ̕
     */
    public static String convertEntityReferences(String target) {
        int len;
        if (target == null || (len = target.length()) == 0) {
            return target;
        }
        StringBuilder sb = new StringBuilder(len * 7);
        String app = null;
        for (int i = 0; i < len; i++) {
            char c = target.charAt(i);
            switch (c) {
            case '"':
                app = "&quot;";
                break;
            case '&':
                app = "&amp;";
                break;
            case '<':
                app = "&lt;";
                break;
            case '>':
                app = "&gt;";
                break;
            case '\'':
                app = "&#39;";
                break;
            case ' ':
                app = "&#160;";
                break;
            case '\u00E4':
                app = "&auml;";
                break;
            case '\u00C4':
                app = "&Auml;";
                break;
            case '\u00F6':
                app = "&ouml;";
                break;
            case '\u00D6':
                app = "&Ouml;";
                break;
            case '\u00FC':
                app = "&uuml;";
                break;
            case '\u00DC':
                app = "&Uuml;";
                break;
            case '\u00DF':
                app = "&szlig;";
                break;
            case '\u20AC':
                app = "&euro;";
                break;
            case '\u00AB':
                app = "&laquo;";
                break;
            case '\u00BB':
                app = "&raquo;";
                break;
            case '\u00A0':
                app = "&#160;";
                break;
            default:
                int ci = c;
                if (ci >= 0x80) {
                    app = "&#" + ci + ";";
                } else {
                    app = Character.toString(c);
                }
                break;
            }
            if (app != null) {
                sb.append(app);
            }
        }
        return sb.toString();
    }

    /**
     * ̕JISɕϊۂɂ܂ϊłȂȉ ̃R[hϊ܂B<br/>
     * <ul>
     * <li>`FFULLWIDTH TILDE(0xff5e) -&gt; WAVE
     * DASH(0x301c)</li>
     * <li>aFPARALLEL TO(0x2225) -&gt; DOUBLE
     * VERTICAL LINE(0x2016)</li>
     * <li>|FFULLWIDTH HYPHEN-MINUS(0xff0d) -&gt;
     * MINUS SIGN(0x2212)</li>
     * <li>\FHORIZONTAL BAR(0x2015) -&gt; EM
     * DASH(0x2014)</li>
     * <li>FFULLWIDTH CENT SIGN(0xffe0) -&gt;
     * CENT SIGN(0x00a2)</li>
     * <li>FFULLWIDTH POUND SIGN(0xffe1) -&gt;
     * POUND SIGN(0x00a3)</li>
     * <li>ʁFFULLWIDTH NOT SIGN(0xffe2) -&gt; NOT
     * SIGN(0x00ac)</li>
     * </ul>
     * 
     * @param target ϊΏۂ̕
     * @return ϊ̕
     */
    public static String convertUnicodeForJIS(String target) {
        int len;
        if (target == null || (len = target.length()) == 0) {
            return target;
        }
        StringBuilder sb = new StringBuilder(len);
        for (int i = 0; i < len; i++) {
            char c = target.charAt(i);
            switch (c) {
            case '\uff5e':
                sb.append('\u301c');
                break;
            case '\u2225':
                sb.append('\u2016');
                break;
            case '\uff0d':
                sb.append('\u2212');
                break;
            case '\u2015':
                sb.append('\u2014');
                break;
            case '\uffe0':
                sb.append('\u00a2');
                break;
            case '\uffe1':
                sb.append('\u00a3');
                break;
            case '\uffe2':
                sb.append('\u00ac');
                break;
            default:
                sb.append(c);
            }
        }
        return sb.toString();
    }

    /**
     * targetUNICODEł̋@ˑ܂܂ĂꍇtrueԂ܂B<br/>
     * LTCg̃e[uɊ܂܂镶@ˑƂĔ肵܂B<br/> <a
     * href="http://www.d-toybox.com/studio/lib/romanNumerals.html#sample"
     * target="_blank"> Unicodeŗpł镶̗</a><br/>
     * A͋̕@ˑ珜Ă܂B<br/>
     * uv<br/> ܂AUnicode<a
     * href="http://www.unicode.org/charts/PDF/UE000.pdf"
     * target="_blank"> Private Use Area</a>@ˑii-mode,
     * vodafone̊G̗̈Ɋ܂܂jƂĔ肵܂B<br/>
     * <ul>
     * QlF
     * <li><a
     * href="http://www.nttdocomo.co.jp/service/imode/make/content/pictograph/index.html"
     * target="_blank">i-modeG</a></li>
     * <li><a
     * href="http://developers.vodafone.jp/dp/tool_dl/web/picword_top.php"
     * target="_blank">vodafoneG</a></li>
     * <li><a
     * href="http://www.au.kddi.com/ezfactory/tec/spec/3.html"
     * target="_blank">ezwebG</a></li>
     * </ul>
     * 
     * @param target Ώۂ̕
     * @return @ˑ܂܂Ăꍇtrue
     */
    public static boolean checkUnicodeModelDependChar(String target) {
        if (target == null || target.length() < 1) {
            return false;
        }
        int len = target.length();
        for (int i = 0; i < len; i++) {
            if (checkUnicodeModelDependChar(target.charAt(i))) {
                return true;
            }
        }
        return false;
    }

    /**
     * targetUNICODEŋ@ˑłƔłꍇtrueԂ܂B<br/>
     * LTCg̃e[uɊ܂܂镶@ˑƂĔ肵܂B<br/> <a
     * href="http://www.d-toybox.com/studio/lib/romanNumerals.html#sample"
     * target="_blank"> Unicodeŗpł镶̗</a><br/>
     * A͋̕@ˑ珜Ă܂B<br/>
     * uv<br/> ܂AUnicode<a
     * href="http://www.unicode.org/charts/PDF/UE000.pdf"
     * target="_blank"> Private Use Area</a>@ˑii-mode,
     * vodafone̊G̗̈Ɋ܂܂jƂĔ肵܂B<br/>
     * <ul>
     * QlF
     * <li><a
     * href="http://www.nttdocomo.co.jp/service/imode/make/content/pictograph/index.html"
     * target="_blank">i-modeG</a></li>
     * <li><a
     * href="http://developers.vodafone.jp/dp/tool_dl/web/picword_top.php"
     * target="_blank">vodafoneG</a></li>
     * <li><a
     * href="http://www.au.kddi.com/ezfactory/tec/spec/3.html"
     * target="_blank">ezwebG</a></li>
     * </ul>
     * 
     * @param target Ώۂ̕
     * @return @ˑłꍇtrue
     */
    public static boolean checkUnicodeModelDependChar(char target) {
        if ((target >= '\u2153' && target <= '\u2182')
                || (target >= '\u2194' && target <= '\u219f')
                || (target >= '\u2460' && target <= '\u24ef')
                || (target >= '\u2600' && target <= '\u2604')
                || (target >= '\u2607' && target <= '\u2613')
                || (target >= '\u261a' && target <= '\u263f')
                || target == '\u2641'
                || (target >= '\u2643' && target <= '\u2669')
                || (target >= '\u266b' && target <= '\u266c')
                || target == '\u266e'
                || (target >= '\u3220' && target <= '\u3243')
                || (target >= '\u3280' && target <= '\u32cb')
                || (target >= '\u32d0' && target <= '\u3376')
                || (target >= '\u337b' && target <= '\u33dd')
                || (target >= '\u33e0' && target <= '\u33fe')
                || (target >= '\ue000' && target <= '\uf8ff')) {
            return true;
        }
        return false;
    }

    //    
    // /**
    // * target̕SĔpJiA@ˑAꕔ̑񐅏
    // * JIS X 0208łꍇtrueԂ܂Bnull܂͒0
    // * łꍇɂtrueԂ܂B
    // *
    // * @param target ؑΏۂƂȂ镶
    // * @return SĂ̕JIS X 0208łꍇtrue
    // * @deprecated
    // */
    // public static boolean isJISX0208(String
    // target) {
    // if (target == null || target.length() < 1)
    // {
    // return true;
    // }
    // int len = target.length();
    // for (int i = 0; i < len; i++) {
    // if (!isJISX0208(target.charAt(i))) {
    // return false;
    // }
    // }
    // return true;
    // }
    //    
    // /**
    // * targetpJiApLi'_'jA@ˑA
    // * 񐅏yёSpryёSpXy[X
    // * JIS X 0208łꍇtrueԂ܂B
    // *
    // * @param target ؑΏۂƂȂ镶
    // * @return SĂ̕JIS X 0208łꍇtrue
    // * @deprecated Ot@CőSĂ̕Ǘ悤ɕύX܂
    // */
    // public static boolean isJISX0208(char
    // target) {
    // int codePoint = 0;
    // try {
    // byte[] bytes =
    // Character.toString(target).getBytes("Windows-31J");
    // int bytesLen = bytes.length;
    // for (int i = 0; i < bytesLen; i++) {
    // int shift = (8 * (bytesLen - i - 1));
    // codePoint = codePoint + ((bytes[i]&0xff) <<
    // shift);
    // }
    // } catch (UnsupportedEncodingException e) {
    // // {JVMł̗͂O͂肦Ȃ̂ŁAsG[Ƃ
    // throw new RuntimeException(e);
    // }
    // // LAЂ炪ȁAJ^Jii`0x84BEj
    // if ((codePoint >= 0x30 && codePoint <=
    // 0x39) || // pp
    // (codePoint >= 0x41 && codePoint <= 0x5A) ||
    // codePoint == 0x5F ||
    // (codePoint >= 0x61 && codePoint <= 0x7A) ||
    // // SpLJniSpXy[Xj
    // (codePoint >= 0x8141 && codePoint <=
    // 0x81AC) ||
    // (codePoint >= 0x81B8 && codePoint <=
    // 0x81BF) ||
    // (codePoint >= 0x81C8 && codePoint <=
    // 0x81CE) ||
    // (codePoint >= 0x81DA && codePoint <=
    // 0x81DF) ||
    // (codePoint >= 0x81E0 && codePoint <=
    // 0x81E8) ||
    // (codePoint >= 0x81F0 && codePoint <=
    // 0x81F7) ||
    // codePoint == 0x81FC ||
    // // SppJn
    // (codePoint >= 0x824F && codePoint <=
    // 0x8258) ||
    // (codePoint >= 0x8260 && codePoint <=
    // 0x8279) ||
    // (codePoint >= 0x8281 && codePoint <=
    // 0x829A) ||
    // // SpЂ炪ȊJn
    // (codePoint >= 0x829F && codePoint <=
    // 0x82F1) ||
    // // SpJ^JiJn
    // (codePoint >= 0x8340 && codePoint <=
    // 0x837E) ||
    // (codePoint >= 0x8380 && codePoint <=
    // 0x8396) ||
    // // SpVAHJn
    // (codePoint >= 0x839F && codePoint <=
    // 0x83B6) ||
    // (codePoint >= 0x83BF && codePoint <=
    // 0x83D6) ||
    // (codePoint >= 0x8440 && codePoint <=
    // 0x8460) ||
    // (codePoint >= 0x8470 && codePoint <=
    // 0x847E) ||
    // (codePoint >= 0x8480 && codePoint <=
    // 0x8491) ||
    // // SprJn
    // // (codePoint >= 0x849F && codePoint <=
    // 0x84BE) ||
    // // ꐅJn
    // (codePoint >= 0x889F && codePoint <=
    // 0x88FC)
    // ) {
    // return true;
    // }
    // // ꐅ̑唼1oCgڂ0x89`0x97
    // if (codePoint >= 0x8940 && codePoint <=
    // 0x97FC) {
    // // ̒0x40`0x7E  0x80`0xFCKp͈
    // int secondByte = 0xFF & codePoint;
    // if ((secondByte >= 0x40 && secondByte <=
    // 0x7E) ||
    // (secondByte >= 0x80 && secondByte <= 0xFC))
    // {
    // return true;
    // } else {
    // return false;
    // }
    // }
    // if ((codePoint >= 0x9840 && codePoint <=
    // 0x9872) // ꐅc
    // // || (codePoint >= 0x989F && codePoint <=
    // 0x98FC) // 񐅏Jn
    // ) {
    // return true;
    // }
    // // // 񐅏̑唼1oCgڂ0x99`0xE9
    // // if (codePoint >= 0x9940 && codePoint <=
    // 0xE9FC) {
    // // // ̒0x40`0x7E0x80`0xFCKp͈
    // // int secondByte = 0xFF & codePoint;
    // // if ((secondByte >= 0x40 && secondByte <=
    // 0x7E) ||
    // // (secondByte >= 0x80 && secondByte <=
    // 0xFC)) {
    // // return true;
    // // } else {
    // // return false;
    // // }
    // // }
    // // // 񐅏ci0xED40`0xFC4B̗͕̈svj
    // // if ((codePoint >= 0xEA40 && codePoint <=
    // 0xEA7E) ||
    // // (codePoint >= 0xEA80 && codePoint <=
    // 0xEAA4)) {
    // // return true;
    // // }
    // return false;
    // }
    //    
    /**
     * SpXy[X܂ޑŐ󔒕܂B
     * 
     * @param str Ώۂ̕
     * @return Trim
     */
    public static String trimHanZen(String str) {
        if (str == null)
            return null;
        int start = 0;
        int len = str.length();
        int end = len;
        for (int i = 0; i < len; i++) {
            char c = str.charAt(i);
            if (!Character.isWhitespace(c) && c != '@') {
                break;
            }
            start++;
        }
        if (start == len) {
            return "";
        }
        for (int i = len - 1; i >= 0; i--) {
            char c = str.charAt(i);
            if (!Character.isWhitespace(c) && c != '@') {
                break;
            }
            end--;
        }
        return str.substring(start, end);
    }

    /**
     * 10ïܓxEoxu/v؂60iɕϊ܂B
     * 
     * @param arg 10iʒu
     * @return 60iʒu
     */
    public static String convert10To60(String arg) {
        if (arg == null)
            return null;
        try {
            return convert10To60(Double.parseDouble(arg));
        } catch (NumberFormatException e) {
            return null;
        }
    }
    
    /**
     * 10ïܓxEoxu/v؂60iɕϊ܂B
     * 
     * @param arg 10iʒu
     * @return 60iʒu
     */
    public static String convert10To60(double pos) {
        StringBuilder sb = new StringBuilder();
        // x
        sb.append((int) Math.floor(pos));
        sb.append("/");
        // 
        double min = (pos - Math.floor(pos)) * 60;
        if (min < 10)
            sb.append("0");
        sb.append((int) Math.floor(min));
        sb.append("/");
        // b
        double sec = Math.round((min - Math.floor(min)) * 60 * 1000) / 1000d;
        if (sec < 10)
            sb.append("0");
        sb.append(sec);
        return sb.toString();
    }

    /**
     * u180/mm/ss.sssv60ïܓxEox10iɕϊ܂B
     * 
     * @param arg 60iʒu
     * @return 10iʒu
     */
    public static String convert60To10(String arg) {
        double ret = convert60to10Double(arg);
        return (ret == Double.NaN) ? null : String.valueOf(ret);
    }
    
    /**
     * u180/mm/ss.sssv60ïܓxEox10iɕϊ܂B
     * 
     * @param arg 60iʒu
     * @return 10iʒu
     */
    public static double convert60to10Double(String arg) {
        if (arg == null)
            return Double.NaN;
        String[] pos = arg.split("/");
        if (pos.length != 3)
            return Double.NaN;
        double position = Double.valueOf(pos[0]).doubleValue();
        position += Double.valueOf(pos[1]).doubleValue() / 60;
        position += Double.valueOf(pos[2]).doubleValue() / 60 / 60;
        return position;
    }
}